/////////////////////////////////////////////////////////////////////////
// SimpleBits - By Nic												   //
//																	   //
// A sh*t Simple Class for writing and reading bits, only use		   //
// bursts of 32 bits as the max. (cant be bothered to support more ;)  //
/////////////////////////////////////////////////////////////////////////

#include "SimpleBits.h"

CSimpleBits::CSimpleBits()
{
	fin = NULL;
	m_nReadBitsLeft = 0;
	m_nCurrentBfr = 0;
}

CSimpleBits::~CSimpleBits()
{
	if ( fin )
		fclose(fin);
}

bool CSimpleBits::SetFileName(const char *szFile, bool bRead)
{
	if ( bRead )
		fin = fopen(szFile, "rb");
	else
		fin = fopen(szFile, "wb");

	return (fin != NULL);
}

unsigned long CSimpleBits::ReadBits(int nBits)
{
	unsigned long nVal  = 0;
	int	nBitsNeeded		= nBits - m_nReadBitsLeft;

	if ( nBitsNeeded <= 0 )
	{
		nVal = (m_nCurrentBfr << (32 - m_nReadBitsLeft)) >> (32 - nBits); 
		m_nReadBitsLeft -= nBits;  
	}
	else
	{
		// We have to load some in
		if ( m_nReadBitsLeft )
		{
			nVal = (m_nCurrentBfr << (32 - m_nReadBitsLeft)) >> (32 - m_nReadBitsLeft);
			nVal <<= 32 - m_nReadBitsLeft;
		}

		fread(&m_nCurrentBfr, 1, 4, fin);
		m_nCurrentBfr = SWAP32(m_nCurrentBfr);
		
		m_nReadBitsLeft = 32;
		nVal |= (m_nCurrentBfr << (32 - m_nReadBitsLeft)) >> (32 - nBitsNeeded);
		
		m_nReadBitsLeft = 32 - nBitsNeeded;
	}

	return nVal;
}

long CSimpleBits::Seek(long pos, int set)
{
	m_nReadBitsLeft = 0;
	m_nCurrentBfr = 0;

	return fseek(fin, pos, set);
}

long CSimpleBits::ReadBytes(void *buf, int buflen)
{
	m_nReadBitsLeft = 0;
	m_nCurrentBfr = 0;

	return fread(buf, 1, buflen, fin);
}

bool CSimpleBits::EndOfFile()
{
	return ( feof(fin) != 0 );
}






